Public Class AddDialPlanForm

    Public Sub OnTelnetCommand(ByVal sCommand As String, ByRef objParamList As ArrayList)

        If String.Compare(sCommand, "AddLine", True) = 0 And objParamList.Count = 1 Then
            ComboLine.Items.Add(objParamList.Item(0))
            Exit Sub
        End If

        If String.Compare(sCommand, "RemoveLine", True) = 0 And objParamList.Count = 1 Then

            Dim nIndex As Integer = ComboLine.FindStringExact(objParamList.Item(0))

            If nIndex = -1 Then
                Exit Sub
            End If

            ComboLine.Items.RemoveAt(nIndex)

            Exit Sub
        End If

        If String.Compare(sCommand, "ShowLines", True) = 0 Then

            Dim nCount As Integer

            For nCount = 0 To objParamList.Count - 1
                ComboLine.Items.Add(objParamList.Item(nCount))
            Next

            If ComboLine.Items.Count > 0 Then
                ComboLine.SelectedIndex = 0
            End If

            Exit Sub
        End If

        If String.Compare(sCommand, "ShowDialPlans", True) = 0 Then

            Dim nCount As Integer

            For nCount = 0 To objParamList.Count - 1
                Dim sDialPlan As String = objParamList.Item(nCount)

                Dim objValueList As ArrayList = New ArrayList
                MainForm.m_objMainForm.ParseToList(sDialPlan, objValueList)

                Dim ListItem As ListViewItem = ListDialPlan.Items.Add(objValueList.Item(0))
                ListItem.SubItems.Add(objValueList.Item(1))
                ListItem.SubItems.Add(objValueList.Item(2))
            Next

            Exit Sub
        End If

        If String.Compare(sCommand, "AddDialPlan", True) = 0 And objParamList.Count = 3 Then

            Dim objListItem As ListViewItem = ListDialPlan.Items.Add(objParamList.Item(0))
            objListItem.SubItems.Add(objParamList.Item(1))
            objListItem.SubItems.Add(objParamList.Item(2))
            Exit Sub

        End If

        If String.Compare(sCommand, "RemoveDialPlan", True) = 0 And objParamList.Count = 1 Then

            Dim objListItem As ListViewItem = ListDialPlan.FindItemWithText(objParamList.Item(0))

            If objListItem Is Nothing Then
                Exit Sub
            End If

            ListDialPlan.Items.Remove(objListItem)

            Exit Sub
        End If

    End Sub

    Private Sub AddDialPlanForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ListDialPlan.Columns.Add("User Prefix", 120, HorizontalAlignment.Left)
        ListDialPlan.Columns.Add("Line Name", 120, HorizontalAlignment.Left)
        ListDialPlan.Columns.Add("Call Prefix", 120, HorizontalAlignment.Left)

        MainForm.m_objMainForm.SendCommand("ShowDialPlans", Nothing)

    End Sub

    Private Sub BtnAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAdd.Click

        If EditUserPrefix.Text.Length = 0 Then
            MessageBox.Show("Please enter the user dial phone no prefix.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        End If

        Dim nCount As Integer

        For nCount = 0 To ListDialPlan.Items.Count - 1

            If EditUserPrefix.Text = ListDialPlan.Items(nCount).Text Then
                MessageBox.Show("Dial plan that user dials phone no with prefix " + EditUserPrefix.Text + " is already exist.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                Exit Sub
            End If

        Next

        If ComboLine.SelectedIndex = -1 Then
            MessageBox.Show("Please select the line.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        End If

        Dim objParamList As ArrayList = New ArrayList

        objParamList.Add(EditUserPrefix.Text)
        objParamList.Add(ComboLine.Text)
        objParamList.Add(EditCallPrefix.Text)

        MainForm.m_objMainForm.SendCommand("AddDialPlan", objParamList)

    End Sub

    Private Sub BtnRemove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRemove.Click

        If ListDialPlan.SelectedItems.Count = 0 Then
            MessageBox.Show("Please select a dial plan.", "VaxTeleSIP", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Exit Sub
        End If

        Dim objParamList As ArrayList = New ArrayList
        objParamList.Add(ListDialPlan.SelectedItems.Item(0).Text)

        MainForm.m_objMainForm.SendCommand("RemoveDialPlan", objParamList)

    End Sub
End Class