Public Class cDialPlanData

    Public m_nUserPrefixSize As Integer
    Public m_sUserPrefix As String
    Public m_sLineName As String
    Public m_sCallPrefix As String

    Public Sub New()

        m_nUserPrefixSize = 0
        m_sUserPrefix = ""
        m_sLineName = ""
        m_sCallPrefix = ""

    End Sub

End Class

Public Class cDialPlanList

    Public m_objDialPlanList As New ArrayList

    Public Sub New()

    End Sub

    Public Sub ReLoadDialPlans()
        UnLoadDialPlans()
        LoadDialPlans()
    End Sub

    Public Sub UnLoadDialPlans()
        m_objDialPlanList.Clear()
    End Sub

    Public Sub LoadDialPlans()


        m_objDialPlanList.Clear()
        Dim objDialPlanList As New ArrayList

        Dim objReg As New cRegistry
        If objReg.EnumDialPlan(objDialPlanList) = False Then
            Exit Sub
        End If

        Dim nCount As Integer
        Dim objDialPlanReg As New cDialPlanReg

        For nCount = 0 To objDialPlanList.Count - 1

            If objReg.GetDialPlan(objDialPlanList.Item(nCount), objDialPlanReg) = False Then
                Continue For
            End If

            Dim objDialPlanData As cDialPlanData = New cDialPlanData

            objDialPlanData.m_sLineName = objDialPlanReg.m_sLineName
            objDialPlanData.m_sCallPrefix = objDialPlanReg.m_sCallPrefix

            objDialPlanData.m_sUserPrefix = objDialPlanList.Item(nCount)
            objDialPlanData.m_nUserPrefixSize = objDialPlanList.Item(nCount).Length

            m_objDialPlanList.Add(objDialPlanData)

        Next



    End Sub

    Public Function SearchDialPlan(ByVal sCallTo As String) As Integer

        Dim nCount As Integer
        Dim objDialPlanData As cDialPlanData

        Dim nPrefixLen As Integer
        Dim nCallToLen As Integer = sCallTo.Length()

        For nCount = 0 To m_objDialPlanList.Count - 1

            objDialPlanData = m_objDialPlanList.Item(nCount)
            nPrefixLen = objDialPlanData.m_nUserPrefixSize

            If nCallToLen <= nPrefixLen Then
                Continue For
            End If

            If sCallTo.Substring(0, nPrefixLen) = objDialPlanData.m_sUserPrefix Then
                SearchDialPlan = nCount
                Exit Function
            End If

        Next

        SearchDialPlan = -1

    End Function

    Public Function ApplyDialPlan(ByVal nDialPlanIndex As Integer, ByVal sCallTo As String, ByRef sLineName As String) As String

        Dim nPrefixLen As Integer

        nPrefixLen = m_objDialPlanList.Item(nDialPlanIndex).m_nUserPrefixSize
        sCallTo = sCallTo.Remove(0, nPrefixLen)

        sLineName = m_objDialPlanList.Item(nDialPlanIndex).m_sLineName

        Dim sCallPrefix As String = m_objDialPlanList.Item(nDialPlanIndex).m_sCallPrefix

        If sCallPrefix.Length = 0 Then
            ApplyDialPlan = sCallTo
            Exit Function
        End If

        ApplyDialPlan = sCallPrefix + sCallTo

    End Function

End Class
