Public Class cLineData

    Public m_nLineId As Integer

    Public m_nCallType As Integer
    Public m_sCallTo As String

    Public m_sLineName As String
    Public m_sCodecList As String

    Public m_bRegister As Boolean

    Public Sub New()

        m_nLineId = 0
        m_nCallType = -1
        m_bRegister = False

        m_sCodecList = ""

    End Sub

End Class

Public Class cLineList

    Dim m_nLineIdCount As Integer

    Dim m_objLineListTEXT As New Hashtable
    Dim m_objLineListINT As New Hashtable

    Public Sub New()
        m_nLineIdCount = 0
    End Sub

    Public Function ChooseLineId() As Integer

        While (True)
            m_nLineIdCount = m_nLineIdCount + 1

            If FindLine(m_nLineIdCount) Is Nothing Then
                Exit While
            End If
        End While

        ChooseLineId = m_nLineIdCount

    End Function

    Public Sub UnLoadLines()

        Dim objCloseLineList As New ArrayList
        Dim enumerator As IDictionaryEnumerator = m_objLineListTEXT.GetEnumerator()

        While enumerator.MoveNext()
            objCloseLineList.Add(enumerator.Key)
        End While

        Dim nCount As Integer
        For nCount = 0 To objCloseLineList.Count - 1
            Remove(objCloseLineList(nCount))
        Next

        m_objLineListTEXT.Clear()
        m_objLineListINT.Clear()

    End Sub

    Public Sub LoadLines()

        UnLoadLines()

        Dim objLineList As New ArrayList
        Dim objReg As New cRegistry

        objReg.EnumLine(objLineList)

        Dim objLineReg As New cLineReg

        Dim nCount As Integer
        For nCount = 0 To objLineList.Count - 1

            Dim sLineName As String = objLineList.Item(nCount)

            If objReg.GetLine(sLineName, objLineReg) = False Then

                cServerSIP.m_objServerSIP.LogError("Unable to extract line information from registry.")
                Continue For

            End If

            Add(sLineName, objLineReg.m_sDisplayName, objLineReg.m_sUserName, objLineReg.m_sAuthUser, objLineReg.m_sPassword, objLineReg.m_sRealm, objLineReg.m_sProxy, objLineReg.m_sOutboundProxy, objLineReg.m_sCodec, objLineReg.m_bRegister, objLineReg.m_sInCallType, objLineReg.m_sInCallTo)

        Next

    End Sub

    Public Function AddLine(ByVal sLineName As String, ByVal sDisplayName As String, ByVal sUserName As String, ByVal sAuthUser As String, ByVal sAuthPwd As String, ByVal sRealm As String, ByVal sProxy As String, ByVal sOutboundProxy As String, ByVal sCodec As String, ByVal bRegister As Boolean, ByVal sInCallType As String, ByVal sInCallTo As String) As Boolean

        Dim objLineReg As New cLineReg

        objLineReg.m_sDisplayName = sDisplayName
        objLineReg.m_sUserName = sUserName
        objLineReg.m_sAuthUser = sAuthUser
        objLineReg.m_sPassword = sAuthPwd
        objLineReg.m_sRealm = sRealm
        objLineReg.m_sProxy = sProxy
        objLineReg.m_sOutboundProxy = sOutboundProxy
        objLineReg.m_sCodec = sCodec

        objLineReg.m_bRegister = bRegister

        objLineReg.m_sInCallType = sInCallType
        objLineReg.m_sInCallTo = sInCallTo

        Dim objReg As New cRegistry
        If objReg.SetLine(sLineName, objLineReg) = False Then
            AddLine = False
            Exit Function
        End If

        Add(sLineName, sDisplayName, sUserName, sAuthUser, sAuthPwd, sRealm, sProxy, sOutboundProxy, sCodec, bRegister, sInCallType, sInCallTo)
        AddLine = True

    End Function

    Public Function RemoveLine(ByVal sLineName As String) As Boolean

        Dim objReg As New cRegistry

        If objReg.RemoveLine(sLineName) = False Then
            RemoveLine = False
            Exit Function
        End If

        Remove(sLineName)
        RemoveLine = True

    End Function

    Public Sub Add(ByVal sLineName As String, ByVal sDisplayName As String, ByVal sUserName As String, ByVal sAuthUser As String, ByVal sAuthPwd As String, ByVal sRealm As String, ByVal sProxy As String, ByVal sOutboundProxy As String, ByVal sCodec As String, ByVal bRegister As Boolean, ByVal sInCallType As String, ByVal sInCallTo As String)

        Remove(sLineName)

        Dim objLineData As New cLineData

        objLineData.m_nCallType = Convert.ToInt32(sInCallType)
        objLineData.m_sCallTo = sInCallTo
        objLineData.m_bRegister = bRegister

        objLineData.m_sLineName = sLineName
        objLineData.m_sCodecList = sCodec

        Dim nLineId As Integer = ChooseLineId()
        objLineData.m_nLineId = nLineId

        m_objLineListINT.Add(nLineId, objLineData)

        sLineName = sLineName.ToLower()
        m_objLineListTEXT.Add(sLineName, objLineData)

        If cServerSIP.m_objServerSIP.AddLine(nLineId, sUserName, sAuthUser, sAuthPwd, sDisplayName, sRealm, sProxy, sOutboundProxy) = False Then

            cServerSIP.m_objServerSIP.LogError("")
            Exit Sub

        End If

        If bRegister = True Then
            If cServerSIP.m_objServerSIP.RegisterLine(nLineId) = False Then
                cServerSIP.m_objServerSIP.LogError("")
            End If
        End If

    End Sub

    Public Sub Remove(ByVal sLineName As String)

        sLineName = sLineName.ToLower()

        Dim objLineData As cLineData = FindLine(sLineName)
        If objLineData Is Nothing Then
            Exit Sub
        End If

        m_objLineListINT.Remove(objLineData.m_nLineId)
        m_objLineListTEXT.Remove(sLineName)

        If objLineData.m_bRegister = True Then
            cServerSIP.m_objServerSIP.UnRegisterLine(objLineData.m_nLineId)
        End If

        objLineData = Nothing

    End Sub

    Public Function FindLine(ByVal nLineId As Integer) As cLineData
        FindLine = m_objLineListINT.Item(nLineId)
    End Function

    Public Function FindLine(ByVal sLineName As String) As cLineData
        FindLine = m_objLineListTEXT.Item(sLineName.ToLower())
    End Function

End Class
