#pragma once

using namespace System;
using namespace System::Collections;
using namespace System::Text;
using namespace System::Diagnostics;

#define CALL_TYPE_REGULAR	0
#define CALL_TYPE_QUEUE		1
#define CALL_TYPE_STEALTH	2

#define PLAY_WAVE_NONE_TYPE			100
#define PLAY_WAVE_DONE_TYPE			101
#define PLAY_WAVE_LOOP_TYPE			102

#define QUEUE_TICK_ID				2001

#define QUEUE_CALL_TYPE				100
#define STEALTH_CALL_TYPE			101
#define BLIND_TRANSFER_CALL_TYPE	102

ref class cVaxTeleCOM;
ref class cCallData;
ref class cCallList;
ref class cLineList;
ref class cDialPlanList;
ref class cQueueList;
ref class cUserList;
ref class cStealthList;
ref class cServerData;
ref class cErrorLog;
ref class cTelnetClient;

ref class cClientRegisterEvent;
ref class cCallEvent;
ref class cResponseEvent;
ref class cHoldCallEvent;
ref class cTransferCallEvent;
ref class cLineRegisterEvent;

public ref class cServerSIP
{

public:
	cServerSIP(void);

private:
	
	PerformanceCounter^ m_objUsageCPU;
	bool m_bStatusRun;

public:

	static cServerSIP^ m_objServerSIP;
	cVaxTeleCOM^ m_objVaxTeleCOM;

public:

	cCallList^ m_objCallList;
    cLineList^ m_objLineList;
    cDialPlanList^ m_objDialPlanList;
    cQueueList^ m_objQueueList;
    cUserList^ m_objUserList;
    cStealthList^ m_objStealthList;

    cServerData^ m_objServerData;
    cErrorLog^ m_objErrorLog;

    Hashtable^ m_objPlayWaveList;

private:

	cClientRegisterEvent^ m_objClientRegEvent;
    cCallEvent^ m_objCallEvent;
    cResponseEvent^ m_objResponseEvent;
    cHoldCallEvent^ m_objHoldCallEvent;
    cTransferCallEvent^ m_objTransferCallEvent;
    cLineRegisterEvent^ m_objLineRegisterEvent;

public:

	bool StartServerSIP();
	void StopServerSIP();

	void UnInitVaxTeleSIP();
	bool InitVaxTeleSIP();
	void BindTwoCall(cCallData^ objCallDataA, cCallData^ objCallDataB);
	bool SendResponse(cCallData^ objCallData, int nStatusCode, String^ sReasonPhrase);
	void CloseCall(cCallData^ objCallData);
	cCallData^ DialCallToLine(cCallData^ objFromCallData, String^ sDialNo, String^ sLineName);
	cCallData^ DialCallToUser(cCallData^ objFromCallData, String^ sToUserId);
	bool AcceptCall(cCallData^ objCallData);
	void CreateSession(cCallData^ objCallData);
	void AddCallToSession(cCallData^ objCallData, int nSessionId);
	void CloseSession(cCallData^ objCallData);
	void TransferCallAccept(cCallData^ objCallData);
	void DisableDetectDTMF(cCallData^ objCallData);
	void EnableDetectDTMF(cCallData^ objCallData);
	bool RejectClientRegister(int nRegId);
	bool AuthClientRegister(int nRegId);
	void OnClientUnRegister(String^ sUserLogin);
	void OnClientRegister(String^ sUserLogin, String^ sDomain, int nRegId);
	void OnClientRegisterSuccess(String^ sUserLogin);
	void OnClientRegisterFail(String^ sUserLogin);
	void OnIncomingCallAnonymous(int nCallId, String^ sCallFrom, String^ sCallTo, String^ sFromURI, String^ sToURI, String^ sFromIP, int nFromPort);
	void OnIncomingCallFromLine(int nCallId, int nLineId, String^ sCallFrom, String^ sCallTo, String^ sFromURI, String^ sToURI, String^ sFromIP, int nFromPort);
	void OnIncomingCallFromUser(int nCallId, String^ sUserName, String^ sCallFrom, String^ sCallTo, String^ sFromURI, String^ sToURI, String^ sFromIP, int nFromPort);
	void StartVoiceStream(cCallData^ objCallDataA, cCallData^ objCallDataB);
	void OnAcceptIncomingCallConnected(int nCallId);
	void OnDialCallConnected(int nCallId);
	void OnDialCallTimeOut(int nCallId);
	void OnAcceptCallTimeOut(int nCallId);
	void OnDisconnectCall(int nCallId);
	void OnIncomingCallCancel(int nCallId);
	void OnSessionLost(int nCallId);
	void OnProvisionalResponse(int nCallId, int nStatusCode, String^ sReasonPhrase);
	void OnFailureResponse(int nCallId, int nStatusCode, String^ sReasonPhrase);
	void OnRedirectionResponse(int nCallId, int nStatusCode, String^ sReasonPhrase, String^ sContact);
	void OnDigitDetectDTMF(int nSessionId, int nCallId, int nDigit);
	void OnHoldCall(int nCallId);
	void OffHoldCall(int nCallId);
	void OnTransferCallBlind(int nCallId, String^ sTransferee, String^ sTransferTo, String^ sTransferToURI);
	void OnTransferCallAttend(int nCallId, int nTransferToCallId);
	bool PlayWaveStopToCall(cCallData^ objCallData);
	bool PlayWaveStartToCall(cCallData^ objCallData, int nPlayWaveId,bool bLoopPlay);
	void OnPlayWaveToSessionDone(int nPlayWaveId, int nSessionId);
	void OnLineRegisterTrying(int nLineId);
	void OnLineRegisterFail(int nLineId, int nStatusCode, String^ sReasonPhrase);
	void OnLineRegisterSuccess(int nLineId);
	void OnLineUnRegisterTrying(int nLineId);
	void OnLineUnRegisterFail(int nLineId, int nStatusCode, String^ sReasonPhrase);
	void OnLineUnRegisterSuccess(int nLineId);
	void OnVaxTeleTick(int nTickId);
	void LogError(String^ sError);
	void LogStatus(String^ sStatus);
	bool LoadWaveFileToSession(String^ sFileName, int% nPlayWaveId, int% nSessionId);
	void UnLoadWaveFileToSession(int nPlayWaveId, int nSessionId);
	bool AddLine(int nLineId, String^ sUserName, String^ sLogin, String^ sLoginPwd, String^ sDisplayName, String^ sDomainRealm, String^ sProxyURI, String^ sOutboundProxy);
	bool RegisterLine(int nLineId);
	bool UnRegisterLine(int nLineId);
	int PlayWaveLoadFile(String^ sFileName);
	void PlayWaveUnLoadFile(int nPlayWaveId);
	bool SetVaxTeleTick(int nTickId, int nElapse);
	bool KillVaxTeleTick(int nTickId);
	bool AddUser(String^ sUserLogin, String^ sLoginPwd);
	void RemoveUser(String^ sUserLogin);
	int GetVaxObjectError();
	void OnTelnetCommand(String^ sCommand, ArrayList^ objParamList, cTelnetClient^ objTelnetClient);
   
};
