#include "StdAfx.h"
#include "VaxTeleCOM.h"
#include "ServerSIP.h"

cVaxTeleCOM::cVaxTeleCOM(void)
{
	m_objVaxTeleCOM = gcnew VaxTeleSIP();

	m_objVaxTeleCOM->OnClientUnRegister += gcnew _IVaxTeleSIPEvents_OnClientUnRegisterEventHandler(&cVaxTeleCOM::OnClientUnRegister);
	m_objVaxTeleCOM->OnClientRegister += gcnew _IVaxTeleSIPEvents_OnClientRegisterEventHandler(&cVaxTeleCOM::OnClientRegister);

	m_objVaxTeleCOM->OnClientRegisterSuccess += gcnew _IVaxTeleSIPEvents_OnClientRegisterSuccessEventHandler(&cVaxTeleCOM::OnClientRegisterSuccess);
	m_objVaxTeleCOM->OnClientRegisterFail += gcnew _IVaxTeleSIPEvents_OnClientRegisterFailEventHandler(&cVaxTeleCOM::OnClientRegisterFail);

	m_objVaxTeleCOM->OnLineRegisterTrying += gcnew _IVaxTeleSIPEvents_OnLineRegisterTryingEventHandler(&cVaxTeleCOM::OnLineRegisterTrying);
	m_objVaxTeleCOM->OnLineRegisterFail += gcnew _IVaxTeleSIPEvents_OnLineRegisterFailEventHandler(&cVaxTeleCOM::OnLineRegisterFail);
	m_objVaxTeleCOM->OnLineRegisterSuccess += gcnew _IVaxTeleSIPEvents_OnLineRegisterSuccessEventHandler(&cVaxTeleCOM::OnLineRegisterSuccess);

	m_objVaxTeleCOM->OnIncomingCallFromLine += gcnew _IVaxTeleSIPEvents_OnIncomingCallFromLineEventHandler(&cVaxTeleCOM::OnIncomingCallFromLine);
	m_objVaxTeleCOM->OnIncomingCallFromUser += gcnew _IVaxTeleSIPEvents_OnIncomingCallFromUserEventHandler(&cVaxTeleCOM::OnIncomingCallFromUser);
	m_objVaxTeleCOM->OnIncomingCallAnonymous += gcnew _IVaxTeleSIPEvents_OnIncomingCallAnonymousEventHandler(&cVaxTeleCOM::OnIncomingCallAnonymous);
	m_objVaxTeleCOM->OnIncomingCallCancel += gcnew _IVaxTeleSIPEvents_OnIncomingCallCancelEventHandler(&cVaxTeleCOM::OnIncomingCallCancel);

	m_objVaxTeleCOM->OnDialCallConnected += gcnew _IVaxTeleSIPEvents_OnDialCallConnectedEventHandler(&cVaxTeleCOM::OnDialCallConnected);
	m_objVaxTeleCOM->OnAcceptIncomingCallConnected += gcnew _IVaxTeleSIPEvents_OnAcceptIncomingCallConnectedEventHandler(&cVaxTeleCOM::OnAcceptIncomingCallConnected);
	m_objVaxTeleCOM->OnDisconnectCall += gcnew _IVaxTeleSIPEvents_OnDisconnectCallEventHandler(&cVaxTeleCOM::OnDisconnectCall);
	m_objVaxTeleCOM->OnSessionLost += gcnew _IVaxTeleSIPEvents_OnSessionLostEventHandler(&cVaxTeleCOM::OnSessionLost);

	m_objVaxTeleCOM->OnProvisionalResponse += gcnew _IVaxTeleSIPEvents_OnProvisionalResponseEventHandler(&cVaxTeleCOM::OnProvisionalResponse);
	m_objVaxTeleCOM->OnFailureResponse += gcnew _IVaxTeleSIPEvents_OnFailureResponseEventHandler(&cVaxTeleCOM::OnFailureResponse);
	m_objVaxTeleCOM->OnRedirectionResponse += gcnew _IVaxTeleSIPEvents_OnRedirectionResponseEventHandler(&cVaxTeleCOM::OnRedirectionResponse);

	m_objVaxTeleCOM->OnPlayWaveToSessionDone += gcnew _IVaxTeleSIPEvents_OnPlayWaveToSessionDoneEventHandler(&cVaxTeleCOM::OnPlayWaveToSessionDone);
	m_objVaxTeleCOM->OnDigitDetectDTMF += gcnew _IVaxTeleSIPEvents_OnDigitDetectDTMFEventHandler(&cVaxTeleCOM::OnDigitDetectDTMF);

	m_objVaxTeleCOM->OnTransferCallBlind += gcnew _IVaxTeleSIPEvents_OnTransferCallBlindEventHandler(&cVaxTeleCOM::OnTransferCallBlind);
	m_objVaxTeleCOM->OnTransferCallAttend += gcnew _IVaxTeleSIPEvents_OnTransferCallAttendEventHandler(&cVaxTeleCOM::OnTransferCallAttend);
	
	m_objVaxTeleCOM->OnHoldCall += gcnew _IVaxTeleSIPEvents_OnHoldCallEventHandler(&cVaxTeleCOM::OnHoldCall);
	m_objVaxTeleCOM->OffHoldCall += gcnew _IVaxTeleSIPEvents_OffHoldCallEventHandler(&cVaxTeleCOM::OffHoldCall);

	m_objVaxTeleCOM->OnDialCallTimeOut += gcnew _IVaxTeleSIPEvents_OnDialCallTimeOutEventHandler(&cVaxTeleCOM::OnDialCallTimeOut);
	m_objVaxTeleCOM->OnAcceptCallTimeOut += gcnew _IVaxTeleSIPEvents_OnAcceptCallTimeOutEventHandler(&cVaxTeleCOM::OnAcceptCallTimeOut);

	m_objVaxTeleCOM->OnLineUnRegisterTrying += gcnew _IVaxTeleSIPEvents_OnLineUnRegisterTryingEventHandler(&cVaxTeleCOM::OnLineUnRegisterTrying);
	m_objVaxTeleCOM->OnLineUnRegisterFail += gcnew _IVaxTeleSIPEvents_OnLineUnRegisterFailEventHandler(&cVaxTeleCOM::OnLineUnRegisterFail);
	m_objVaxTeleCOM->OnLineUnRegisterSuccess += gcnew _IVaxTeleSIPEvents_OnLineUnRegisterSuccessEventHandler(&cVaxTeleCOM::OnLineUnRegisterSuccess);

	m_objVaxTeleCOM->OnVaxTeleTick += gcnew _IVaxTeleSIPEvents_OnVaxTeleTickEventHandler(&cVaxTeleCOM::OnVaxTeleTick);
}

void cVaxTeleCOM::SetLicenseKey(String^ sLicenseKey)
{
    m_objVaxTeleCOM->SetLicenseKey(sLicenseKey);
}

void cVaxTeleCOM::UnInitialize()
{
    m_objVaxTeleCOM->UnInitialize();
}

bool cVaxTeleCOM::Initialize(String^ sDomainRealm, String^ sSIPListenIP, int nSIPListenPort, String^ sRTPListenIP, int nRTPListenPort)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->Initialize(sDomainRealm, sSIPListenIP, nSIPListenPort, sRTPListenIP, nRTPListenPort));
}

bool cVaxTeleCOM::AcceptCall(int nCallId, String^ sCodecList, int nTimeOut)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->AcceptCall(nCallId, sCodecList, nTimeOut));
}

bool cVaxTeleCOM::CloseCall(int nCallId)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->CloseCall(nCallId));
}

int cVaxTeleCOM::CreateSession()
{
   return m_objVaxTeleCOM->CreateSession();
}

bool cVaxTeleCOM::AddCallToSession(int nCallId, int nSessionId)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->AddCallToSession(nCallId, nSessionId));
}

bool cVaxTeleCOM::RemoveCallToSession(int nCallId)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->RemoveCallToSession(nCallId));
}

void cVaxTeleCOM::CloseSession(int nSessionId)
{
    m_objVaxTeleCOM->CloseSession(nSessionId);
}

int cVaxTeleCOM::GetVaxObjectError()
{
    return m_objVaxTeleCOM->GetVaxObjectError();
}

int cVaxTeleCOM::DialCallToUser(String^ sCallFrom, String^ sToUserLogin, String^ sCodecList, int nTimeOut)
{
    return m_objVaxTeleCOM->DialCallToUser(sCallFrom, sToUserLogin, sCodecList, nTimeOut);
}

int cVaxTeleCOM::DialCallToLine(int nLineId, String^ sDialNo, String^ sCodecList, int nTimeOut)
{
    return m_objVaxTeleCOM->DialCallToLine(nLineId, sDialNo, sCodecList, nTimeOut);
}

int cVaxTeleCOM::DialCallToURI(String^ sFromURI, String^ sToURI, String^ sProxyURI, String^ sLogin, String^ sLoginPwd, String^ sCodecList, int nTimeOut)
{
    return m_objVaxTeleCOM->DialCallToURI(sFromURI, sToURI, sProxyURI, sLogin, sLoginPwd, sCodecList, nTimeOut);
}

bool cVaxTeleCOM::SendResponse(int nCallId, int nStatusCode, String^ sReasonPhrase, String^ sCodecList)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->SendResponse(nCallId, nStatusCode, sReasonPhrase, sCodecList));
}

bool cVaxTeleCOM::RegisterLine(int nLineId)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->RegisterLine(nLineId));
}

bool cVaxTeleCOM::UnRegisterLine(int nLineId)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->UnRegisterLine(nLineId));
}

bool cVaxTeleCOM::AddLine(int nLineId, String^ sUserName, String^ sLogin, String^ sLoginPwd, String^ sDisplayName, String^ sDomainRealm, String^ sProxyURI, String^ sOutboundProxy)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->AddLine(nLineId, sUserName, sLogin, sLoginPwd, sDisplayName, sDomainRealm, sProxyURI, sOutboundProxy));
}

void cVaxTeleCOM::RemoveLine(int nLineId)
{
    m_objVaxTeleCOM->RemoveLine(nLineId);
}
    
bool cVaxTeleCOM::AddUser(String^ sUserLogin, String^ sLoginPwd)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->AddUser(sUserLogin, sLoginPwd));
}

void cVaxTeleCOM::RemoveUser(String^ sUserLogin)
{
    m_objVaxTeleCOM->RemoveUser(sUserLogin);
}
    
bool cVaxTeleCOM::AuthClientRegister(int nRegId)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->AuthClientRegister(nRegId));
}

bool cVaxTeleCOM::AcceptClientRegister(int nRegId)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->AcceptClientRegister(nRegId));
}

bool cVaxTeleCOM::RejectClientRegister(int nRegId)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->RejectClientRegister(nRegId));
}

int cVaxTeleCOM::PlayWaveLoadFile(String^ sFileName)
{
    return m_objVaxTeleCOM->PlayWaveLoadFile(sFileName);
}

void cVaxTeleCOM::PlayWaveUnLoadFile(int nPlayWaveId)
{
    m_objVaxTeleCOM->PlayWaveUnLoadFile(nPlayWaveId);
}

bool cVaxTeleCOM::PlayWaveStartToSession(int nPlayWaveId, int nSessionId, bool bLoopPlay)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->PlayWaveStartToSession(nPlayWaveId, nSessionId, Convert::ToInt16(bLoopPlay)));
}

bool cVaxTeleCOM::PlayWaveStopToSession(int nSessionId)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->PlayWaveStopToSession(nSessionId));
}

bool cVaxTeleCOM::PlayWaveResetToSession(int nSessionId)
{   	
    return Convert::ToBoolean(m_objVaxTeleCOM->PlayWaveResetToSession(nSessionId));
}

bool cVaxTeleCOM::RecordWaveStartToSession(String^ sFileName, int nSessionId)
{	
    return Convert::ToBoolean(m_objVaxTeleCOM->RecordWaveStartToSession(sFileName, nSessionId));
}

bool cVaxTeleCOM::RecordWaveStopToSession(int nSessionId)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->RecordWaveStopToSession(nSessionId));
}

bool cVaxTeleCOM::RecordWavePauseToSession(bool bEnable, int nSessionId)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->RecordWavePauseToSession(Convert::ToInt32(bEnable), nSessionId));
}

bool cVaxTeleCOM::TransferCallAccept(int nCallId)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->TransferCallAccept(nCallId));
}

bool cVaxTeleCOM::TransferCallReject(int nCallId)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->TransferCallReject(nCallId));
}

bool cVaxTeleCOM::SendDTMF(int nTypeDTMF, int nCallId, int nDigit)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->SendDTMF(nTypeDTMF, nCallId, nDigit));
}

bool cVaxTeleCOM::DetectDTMF(int nTypeDTMF, int nSessionId, bool bEnable)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->DetectDTMF(nTypeDTMF, nSessionId, Convert::ToInt32(bEnable)));
}
    
bool cVaxTeleCOM::SessionLost(bool bEnable)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->SessionLost(Convert::ToInt32(bEnable)));
}

int cVaxTeleCOM::GetCallSession(int nCallId)
{
    return m_objVaxTeleCOM->GetCallSession(nCallId);
}

bool cVaxTeleCOM::EnableDialTone(int nCallId, int nSessionId)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->EnableDialTone(nCallId, nSessionId));
}

bool cVaxTeleCOM::DisableDialTone(int nCallId)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->DisableDialTone(nCallId));
}

bool cVaxTeleCOM::SetVaxTeleTick(int nTickId, int nElapse)
{
    return Convert::ToBoolean(m_objVaxTeleCOM->SetVaxTeleTick(nTickId, nElapse));
}

bool cVaxTeleCOM::KillVaxTeleTick(int nTickId)
{
	return Convert::ToBoolean(m_objVaxTeleCOM->KillVaxTeleTick(nTickId));
}

void cVaxTeleCOM::OnClientUnRegister(String^ sUserLogin) 
{
    cServerSIP::m_objServerSIP->OnClientUnRegister(sUserLogin);
}

void cVaxTeleCOM::OnClientRegister(String^ sUserLogin, String^ sDomain, int nRegId) 
{
    cServerSIP::m_objServerSIP->OnClientRegister(sUserLogin, sDomain, nRegId);
}

void cVaxTeleCOM::OnClientRegisterSuccess(String^ sUserLogin) 
{
    cServerSIP::m_objServerSIP->OnClientRegisterSuccess(sUserLogin);
}

void cVaxTeleCOM::OnClientRegisterFail(String^ sUserLogin) 
{
    cServerSIP::m_objServerSIP->OnClientRegisterFail(sUserLogin);
}

void cVaxTeleCOM::OnLineRegisterTrying(int nLineId) 
{
    cServerSIP::m_objServerSIP->OnLineRegisterTrying(nLineId);
}

void cVaxTeleCOM::OnLineRegisterFail(int nLineId, int nStatusCode, String^ sReasonPhrase) 
{
    cServerSIP::m_objServerSIP->OnLineRegisterFail(nLineId, nStatusCode, sReasonPhrase);
}

void cVaxTeleCOM::OnLineRegisterSuccess(int nLineId) 
{
    cServerSIP::m_objServerSIP->OnLineRegisterSuccess(nLineId);
}

void cVaxTeleCOM::OnIncomingCallFromLine(int nCallId, int nLineId, String^ sCallFrom, String^ sCallTo, String^ sFromURI, String^ sToURI, String^ sFromIP, int nFromPort) 
{
    cServerSIP::m_objServerSIP->OnIncomingCallFromLine(nCallId, nLineId, sCallFrom, sCallTo, sFromURI, sToURI, sFromIP, nFromPort);
}

void cVaxTeleCOM::OnIncomingCallFromUser(int nCallId, String^ sUserName, String^ sCallFrom, String^ sCallTo, String^ sFromURI, String^ sToURI, String^ sFromIP, int nFromPort) 
{
    cServerSIP::m_objServerSIP->OnIncomingCallFromUser(nCallId, sUserName, sCallFrom, sCallTo, sFromURI, sToURI, sFromIP, nFromPort);
}

void cVaxTeleCOM::OnIncomingCallAnonymous(int nCallId, String^ sCallFrom, String^ sCallTo, String^ sFromURI, String^ sToURI, String^ sFromIP, int nFromPort) 
{
    cServerSIP::m_objServerSIP->OnIncomingCallAnonymous(nCallId, sCallFrom, sCallTo, sFromURI, sToURI, sFromIP, nFromPort);
}

void cVaxTeleCOM::OnIncomingCallCancel(int nCallId) 
{
    cServerSIP::m_objServerSIP->OnIncomingCallCancel(nCallId);
}

void cVaxTeleCOM::OnDialCallConnected(int nCallId) 
{
    cServerSIP::m_objServerSIP->OnDialCallConnected(nCallId);
}

void cVaxTeleCOM::OnAcceptIncomingCallConnected(int nCallId) 
{
    cServerSIP::m_objServerSIP->OnAcceptIncomingCallConnected(nCallId);
}

void cVaxTeleCOM::OnDisconnectCall(int nCallId) 
{
    cServerSIP::m_objServerSIP->OnDisconnectCall(nCallId);
}

void cVaxTeleCOM::OnSessionLost(int nCallId)
{
    cServerSIP::m_objServerSIP->OnSessionLost(nCallId);
}

void cVaxTeleCOM::OnDialCallTimeOut(int nCallId)
{
    cServerSIP::m_objServerSIP->OnDialCallTimeOut(nCallId);
}

void cVaxTeleCOM::OnAcceptCallTimeOut(int nCallId)
{
    cServerSIP::m_objServerSIP->OnAcceptCallTimeOut(nCallId);
}

void cVaxTeleCOM::OnProvisionalResponse(int nCallId, int nStatusCode, String^ sReasonPhrase) 
{
    cServerSIP::m_objServerSIP->OnProvisionalResponse(nCallId, nStatusCode, sReasonPhrase);
}

void cVaxTeleCOM::OnFailureResponse(int nCallId, int nStatusCode, String^ sReasonPhrase) 
{
    cServerSIP::m_objServerSIP->OnFailureResponse(nCallId, nStatusCode, sReasonPhrase);
}

void cVaxTeleCOM::OnRedirectionResponse(int nCallId, int nStatusCode, String^ sReasonPhrase, String^ sContact) 
{
    cServerSIP::m_objServerSIP->OnRedirectionResponse(nCallId, nStatusCode, sReasonPhrase, sContact);
}

void cVaxTeleCOM::OnPlayWaveToSessionDone(int nPlayWaveId, int nSessionId) 
{
    cServerSIP::m_objServerSIP->OnPlayWaveToSessionDone(nPlayWaveId, nSessionId);
}

void cVaxTeleCOM::OnDigitDetectDTMF(int nSessionId, int nCallId, int nDigit) 
{
    cServerSIP::m_objServerSIP->OnDigitDetectDTMF(nSessionId, nCallId, nDigit);
}
    
void cVaxTeleCOM::OnTransferCallBlind(int nCallId, String^ sTransferee, String^ sTransferTo, String^ sTransferToURI) 
{
    cServerSIP::m_objServerSIP->OnTransferCallBlind(nCallId, sTransferee, sTransferTo, sTransferToURI);
}

void cVaxTeleCOM::OnTransferCallAttend(int nCallId, int nTransferToCallId) 
{
    cServerSIP::m_objServerSIP->OnTransferCallAttend(nCallId, nTransferToCallId);
}

void cVaxTeleCOM::OnHoldCall(int nCallId) 
{
    cServerSIP::m_objServerSIP->OnHoldCall(nCallId);
}

void cVaxTeleCOM::OffHoldCall(int nCallId) 
{
    cServerSIP::m_objServerSIP->OffHoldCall(nCallId);
}
    
void cVaxTeleCOM::OnVaxTeleTick(int nTickId) 
{
    cServerSIP::m_objServerSIP->OnVaxTeleTick(nTickId);
}

void cVaxTeleCOM::OnLineUnRegisterTrying(int nLineId)
{
    cServerSIP::m_objServerSIP->OnLineUnRegisterTrying(nLineId);
}

void cVaxTeleCOM::OnLineUnRegisterFail(int nLineId, int nStatusCode, String^ sReasonPhrase)
{
    cServerSIP::m_objServerSIP->OnLineUnRegisterFail(nLineId, nStatusCode, sReasonPhrase);
}

void cVaxTeleCOM::OnLineUnRegisterSuccess(int nLineId)
{
    cServerSIP::m_objServerSIP->OnLineUnRegisterSuccess(nLineId);
}