// LineList.h: interface for the CLineList class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LINELIST_H__C1A6CEEA_EE86_49B6_81DB_4978D74442F3__INCLUDED_)
#define AFX_LINELIST_H__C1A6CEEA_EE86_49B6_81DB_4978D74442F3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CVaxTeleServerSIP;

class CLineData
{

public:

	CLineData(){m_lLineId = 0; m_dwCallType = -1; m_bRegister = FALSE;}

	LONG m_lLineId;

	DWORD m_dwCallType; 
	CString m_sCallTo;

	CString m_sLineName;
	CString m_sCodecList;

	BOOL m_bRegister;
};

typedef CMap<CString, LPCTSTR, CLineData*, CLineData*> CMapLineStrToPtr;
typedef CMap<ULONG, ULONG, CLineData*, CLineData*> CMapLineULongToPtr;

class CLineList  
{
public:

	CLineList();
	~CLineList();

private:

	LONG m_lLineIdCount;

	CMapLineStrToPtr* m_pLineListTEXT;
	CMapLineULongToPtr* m_pLineListINT;

	LONG ChooseLineId();
	
	void Add(CString sLineName, LPCTSTR sDisplayName, LPCTSTR sUserName, LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sRealm, LPCTSTR sProxy, LPCTSTR sOutboundProxy, LPCTSTR sCodec, BOOL bRegister, LPCTSTR sInCallType, LPCTSTR sInCallTo);
	void Remove(CString sLineName);

public:

	void LoadLines();
	void UnLoadLines();

	CLineData* CLineList::CreateLine(CString sLineName);

	BOOL AddLine(LPCTSTR sLineName, LPCTSTR sDisplayName, LPCTSTR sUserName, LPCTSTR sAuthUser, LPCTSTR sAuthPwd, LPCTSTR sRealm, LPCTSTR sProxy, LPCTSTR sOutboundProxy, LPCTSTR sCodec, BOOL bRegister, LPCTSTR sInCallType, LPCTSTR sInCallTo);
	BOOL RemoveLine(LPCTSTR sLineName);
	
	CLineData* FindLine(long lLineId);
	CLineData* FindLine(CString sLineId);

	//void DeleteAll();
};

#endif // !defined(AFX_LINELIST_H__C1A6CEEA_EE86_49B6_81DB_4978D74442F3__INCLUDED_)
