using System;
using System.Collections;
using System.Text;
using Microsoft.Win32;

class cQueueReg
{
    public string m_sPlayWave;
    public string m_sPressDigitPlayWave;

    public ArrayList m_objQueueOPList;
    public ArrayList m_objPressDigitList;
    public ArrayList m_objPressDigitUserList;
}

class cLoginReg
{
    public string m_sPassword;
    public string m_sCodec;
    public Boolean m_bBlock;
    public Boolean m_bStealth;
}

class cLineReg
{
    public string m_sDisplayName;
    public string m_sUserName;
    public string m_sAuthUser;
    public string m_sPassword;
    public string m_sRealm;
    public string m_sProxy;
    public string m_sOutboundProxy;
    public Boolean m_bRegister;
    public string m_sInCallType;
    public string m_sInCallTo;
    public string m_sCodec;
}

class cDialPlanReg
{
    public string m_sLineName;
    public string m_sCallPrefix;
}

class cRegistry
{
    private RegistryKey m_hKey;

    public cRegistry()
    {
        m_hKey = Registry.LocalMachine.CreateSubKey("SOFTWARE\\VaxTeleSrvSIP");
    }

    ~cRegistry()
    {
        if (m_hKey != null)
            m_hKey.Close();
    }

    public string GetStealthListenerMusic()
    {
        if (m_hKey == null)
            return "";

        return (string)m_hKey.GetValue("StealthListenMusic", "");
    }

    public Boolean SetStealthListenerMusic(string sPlayWave)
    {
        if (m_hKey == null)
            return false;

        m_hKey.SetValue("StealthListenMusic", sPlayWave);

        return true;
    }

    public string GetHoldMusic()
    {
        if (m_hKey == null)
            return "";

        return (string)m_hKey.GetValue("HoldMusic", "");
    }

    public Boolean SetHoldMusic(string sPlayWave)
    {
        if (m_hKey == null)
            return false;

        m_hKey.SetValue("HoldMusic", sPlayWave);

        return true;
    }

    public string GetDialToneMusic()
    {
        if (m_hKey == null)
            return "";

        return (string)m_hKey.GetValue("DialToneMusic", "");
    }

    public Boolean SetDialToneMusic(string sPlayWave)
    {
        if (m_hKey == null)
            return false;

        m_hKey.SetValue("DialToneMusic", sPlayWave);

        return true;
    }

    public Boolean GetStartServer()
    {
        if(m_hKey == null) return false;
            
        return Convert.ToBoolean(m_hKey.GetValue("ServerStart", true));
    }

    public Boolean SetStartServer(Boolean bEnable)
    {
        if(m_hKey == null) return false;
        
        m_hKey.SetValue("ServerStart", bEnable, RegistryValueKind.DWord);

        return true;
    }

    public Boolean SetComm(string sListenIP, string sListenPort, string sDominRealm)
    {
        if (m_hKey == null)
            return false;

        m_hKey.SetValue("ListenIP", sListenIP);
        m_hKey.SetValue("ListenPort", sListenPort);
        m_hKey.SetValue("DomainRealm", sDominRealm);

        return true;
    }

    public Boolean GetComm(ref string sListenIP, ref string sListenPort, ref string sDominRealm)
    {
        if (m_hKey == null)
            return false;

        sListenIP = (string) m_hKey.GetValue("ListenIP", "");
        sListenPort = (string) m_hKey.GetValue("ListenPort", "5060");
        sDominRealm = (string) m_hKey.GetValue("DomainRealm", "");

        return true;
    }

    ///////////////////////////////////////////////////////

    public Boolean RemoveQueue(string sQueue)
    {
        if (m_hKey == null)
            return false;

        m_hKey.DeleteSubKey("Queue\\" + sQueue);

        return true;
    }

    public Boolean EnumQueue(ref ArrayList objQueueList)
    {
        if (m_hKey == null) return false;

        RegistryKey hKey = m_hKey.OpenSubKey("Queue", false);
        if (hKey == null) return false;

        string[] arrayQueue = (string[])hKey.GetSubKeyNames();

        for (int nCount = 0; nCount < arrayQueue.Length; nCount++)
            objQueueList.Add(arrayQueue[nCount]);
        
        hKey.Close();
        return true;
    }

    public Boolean GetQueue(string sQueue, ref cQueueReg objQueueReg)
    {
        if (m_hKey == null) return false;

        RegistryKey hKey = m_hKey.OpenSubKey("Queue\\" + sQueue, false);
        if (hKey == null) return false;

        objQueueReg.m_objQueueOPList = new ArrayList();

        for (int nCount = 0; ; nCount++)
        {
            string sValue = (string)hKey.GetValue("op-" + nCount.ToString());
            if (sValue == null) break;

            objQueueReg.m_objQueueOPList.Add(sValue);
        }
                
        objQueueReg.m_objPressDigitList = new ArrayList();

        for (int nCount = 0; ; nCount++)
        {
            string sValue = (string)hKey.GetValue("digit-" + nCount.ToString());
            if (sValue == null) break;

            objQueueReg.m_objPressDigitList.Add(sValue);
        }

        objQueueReg.m_objPressDigitUserList = new ArrayList();

        for (int nCount = 0;;nCount++)
        {
            string sValue = (string)hKey.GetValue("digituser-" + nCount.ToString());
            if (sValue == null) break;

            objQueueReg.m_objPressDigitUserList.Add(sValue);
        }
                
        objQueueReg.m_sPressDigitPlayWave = (string)hKey.GetValue("digitplaywave", "");
        objQueueReg.m_sPlayWave = (string)hKey.GetValue("playwave", "");

        hKey.Close();

        return true;
    }

    public Boolean SetQueue(string sQueue, ref cQueueReg objQueueReg)
    {
        if (m_hKey == null) return false;

        RegistryKey hKey = m_hKey.CreateSubKey("Queue\\" + sQueue);
        if (hKey == null) return false;

        for (int nCount = 0; nCount < objQueueReg.m_objQueueOPList.Count; nCount++)
            hKey.SetValue("op-" + nCount.ToString(), objQueueReg.m_objQueueOPList[nCount]);

        for (int nCount = 0; nCount < objQueueReg.m_objPressDigitList.Count; nCount++)
            hKey.SetValue("digit-" + nCount.ToString(), objQueueReg.m_objPressDigitList[nCount]);

        for (int nCount = 0; nCount < objQueueReg.m_objPressDigitUserList.Count; nCount++)
            hKey.SetValue("digituser-" + nCount.ToString(), objQueueReg.m_objPressDigitUserList[nCount]);

        hKey.SetValue("playwave", objQueueReg.m_sPlayWave);
        hKey.SetValue("digitplaywave", objQueueReg.m_sPressDigitPlayWave);

        hKey.Close();

        return true;
    }

    public Boolean IsQueueExist(string sQueue)
    {
        if (m_hKey == null) return false;

        RegistryKey hKey = m_hKey.OpenSubKey("Queue\\" + sQueue, false);
        if (hKey == null) return false;

        hKey.Close();
        return true;
    }

    public Boolean RemoveLogin(string sLogin)
    {
        if (m_hKey == null) return false;

        m_hKey.DeleteSubKey("Login\\" + sLogin);
        return true;
    }

    public Boolean EnumLogin(ref ArrayList objLoginList)
    {
        if (m_hKey == null) return false;

        RegistryKey hKey = m_hKey.OpenSubKey("Login", false);
        if (hKey == null) return false;

        string[] arrayLogin = (string[])hKey.GetSubKeyNames();

        for (int nCount = 0; nCount < arrayLogin.Length; nCount++)
            objLoginList.Add(arrayLogin[nCount]);

        hKey.Close();
        return true;
    }

    public Boolean SetLogin(string sLogin, ref cLoginReg objLoginReg)
    {
        if (m_hKey == null) return false;

        RegistryKey hKey = m_hKey.CreateSubKey("Login\\" + sLogin);
        if (hKey == null) return false;

        hKey.SetValue("password", objLoginReg.m_sPassword);
        hKey.SetValue("codec", objLoginReg.m_sCodec);
        hKey.SetValue("block", objLoginReg.m_bBlock, RegistryValueKind.DWord);
        hKey.SetValue("stealth", objLoginReg.m_bStealth, RegistryValueKind.DWord);

        hKey.Close();
        return true;
    }

    public Boolean GetLogin(string sLogin, ref cLoginReg objLoginReg)
    {
        if (m_hKey == null) return false;

        RegistryKey hKey = m_hKey.OpenSubKey("Login\\" + sLogin, false);
        if (hKey == null) return false;

        objLoginReg.m_sPassword = (string)hKey.GetValue("password", "");
        objLoginReg.m_bBlock = Convert.ToBoolean(hKey.GetValue("block", true));
        objLoginReg.m_bStealth = Convert.ToBoolean(hKey.GetValue("stealth", false));
        objLoginReg.m_sCodec = (string)hKey.GetValue("codec", "32014");

        hKey.Close();
        return true;
    }

    public Boolean IsLoginExist(string sLogin)
    {
        if (m_hKey == null) return false;

        RegistryKey hKey = m_hKey.OpenSubKey("Login\\" + sLogin, false);
        if (hKey == null) return false;

        hKey.Close();
        return true;
    }
    
    /*============================================*/

    public Boolean EnumLine(ref ArrayList objLineList)
    {
        if (m_hKey == null) return false;

        RegistryKey hKey = m_hKey.OpenSubKey("Line", false);
        if (hKey == null) return false;

        string[] arrayLine = (string[])hKey.GetSubKeyNames();

        for (int nCount = 0; nCount < arrayLine.Length; nCount++)
            objLineList.Add(arrayLine[nCount]);

        hKey.Close();
        return true;
    }

    public Boolean SetLine(string sLineName, ref cLineReg objLineReg)
    {
        if (m_hKey == null) return false;

        RegistryKey hKey = m_hKey.CreateSubKey("Line\\" + sLineName);
        if (hKey == null) return false;

        hKey.SetValue("displayname", objLineReg.m_sDisplayName);
        hKey.SetValue("username", objLineReg.m_sUserName);
        hKey.SetValue("authuser", objLineReg.m_sAuthUser);
        hKey.SetValue("password", objLineReg.m_sPassword);
        hKey.SetValue("realm", objLineReg.m_sRealm);
        hKey.SetValue("proxy", objLineReg.m_sProxy);
        hKey.SetValue("outboundproxy", objLineReg.m_sOutboundProxy);
        hKey.SetValue("codec", objLineReg.m_sCodec);
        hKey.SetValue("regonstartup", objLineReg.m_bRegister, RegistryValueKind.DWord);
        hKey.SetValue("incalltype", objLineReg.m_sInCallType);
        hKey.SetValue("incallto", objLineReg.m_sInCallTo);

        hKey.Close();
        return true;
    }

    public Boolean GetLine(string sLineName, ref cLineReg objLineReg)
    {
        if (m_hKey == null) return false;

        RegistryKey hKey = m_hKey.OpenSubKey("Line\\" + sLineName, false);
        if (hKey == null) return false;

        objLineReg.m_sDisplayName = (string)hKey.GetValue("displayname", "");
        objLineReg.m_sUserName = (string)hKey.GetValue("username", "");
        objLineReg.m_sAuthUser = (string)hKey.GetValue("authuser", "");
        objLineReg.m_sPassword = (string)hKey.GetValue("password", "");
        objLineReg.m_sRealm = (string)hKey.GetValue("realm", "");
        objLineReg.m_sProxy = (string)hKey.GetValue("proxy", "");
        objLineReg.m_sOutboundProxy = (string)hKey.GetValue("outboundproxy", "");

        objLineReg.m_sCodec = (string)hKey.GetValue("codec", "32014");

        objLineReg.m_bRegister = Convert.ToBoolean(hKey.GetValue("regonstartup", false));

        objLineReg.m_sInCallType = (string)hKey.GetValue("incalltype", "");
        objLineReg.m_sInCallTo = (string)hKey.GetValue("incallto", "");

        hKey.Close();
        return true;
    }

    public Boolean IsLineExist(string sLineName)
    {
        if (m_hKey == null) return false;

        RegistryKey hKey = m_hKey.OpenSubKey("Line\\" + sLineName, false);
        if (hKey == null) return false;

        hKey.Close();
        return true;
    }

    public Boolean RemoveLine(string sLineName)
    {
        if (m_hKey == null) return false;

        m_hKey.DeleteSubKey("Line\\" + sLineName);

        return true;
    }

    /*============================================*/

    public Boolean EnumDialPlan(ref ArrayList objUserPrefix)
    {
        if (m_hKey == null) return false;

        RegistryKey hKey = m_hKey.OpenSubKey("DialPlan", false);
        if (hKey == null) return false;

        string[] arrayUserPrefix = (string[])hKey.GetSubKeyNames();

        for (int nCount = 0; nCount < arrayUserPrefix.Length; nCount++)
            objUserPrefix.Add(arrayUserPrefix[nCount]);

        hKey.Close();
        return true;
    }

    public Boolean RemoveDialPlan(string sUserPrefix)
    {
        if (m_hKey == null) return false;

        m_hKey.DeleteSubKey("DialPlan\\" + sUserPrefix);

        return true;
    }

    public Boolean SetDialPlan(string sUserPrefix, ref cDialPlanReg objDialPlanReg)
    {
        if (m_hKey == null) return false;

        RegistryKey hKey = m_hKey.CreateSubKey("DialPlan\\" + sUserPrefix);
        if (hKey == null) return false;

        hKey.SetValue("LineName", objDialPlanReg.m_sLineName);
        hKey.SetValue("CallPrefix", objDialPlanReg.m_sCallPrefix);

        hKey.Close();
        return true;
    }

    public Boolean GetDialPlan(string sUserPrefix, ref cDialPlanReg objDialPlanReg)
    {
        if (m_hKey == null) return false;

        RegistryKey hKey = m_hKey.OpenSubKey("DialPlan\\" + sUserPrefix, false);
        if (hKey == null) return false;

        objDialPlanReg.m_sLineName = (string)hKey.GetValue("LineName", "");
        objDialPlanReg.m_sCallPrefix = (string)hKey.GetValue("CallPrefix", "");

        hKey.Close();
        return true;
    }
}
       